﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
/*Add this line to use ExcelWriter:*/
using SoftArtisans.OfficeWriter.ExcelWriter;

namespace HelloWorld
{
    public partial class ExcelApplication_HelloWorld : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            ErrorLabel.Visible = false;
        }

        protected void RunHelloWorld_Click(object sender, EventArgs e)
        {
            try
            {
                /*Instantiate the ExcelApplication object
                 * The ExcelApplication object works like a file generation
                 * engine. Workbooks are created, opened, and saved
                 * from the ExcelApplication object.*/
                ExcelApplication XLAPP = new ExcelApplication();

                /*Create a new workbook
                 * The Excel2007 file format is XLSX.
                 * ExcelWriter automatically creates the first worksheet
                 * in a new workbook. */
                Workbook WB = XLAPP.Create(ExcelApplication.FileFormat.Xlsx);

                /*Access the first worksheet*/
                Worksheet WKST = WB.Worksheets[0];

                //Change the value in a cell
                string value = DataValueBox.Text.Trim();
                WKST.Cells[0,0].Value = value;

                /*Save the workbook
                 * This is streaming the workbook back as an attachment.*/
                XLAPP.Save(WB, Page.Response, "Output.xlsx", false);

            }
            catch (Exception ex)
            {
                ErrorLabel.Visible = true;
                if (ex.Message.Contains("General license key exception"))
                {
                    ErrorLabel.Text = "OfficeWriter does not appear to be" +
                       " installed on this machine. If you have not " +
                       "purchased OfficeWriter, you can download the "+
                       "evaluation version here: "+
                       "http://www.officewriter.com/officewriter-free-evaluation.aspx";
                }
                else
                {
                    ErrorLabel.Text = ex.Message;
                }

            }
        }
    }
}
